/* 
    OrppCE - Oroo Motioncontroller interface example
    (C) 2005 Jason Hunt

    nulluser@gmail.comx

    FILE: display.cpp
*/


#include <windows.h>

#include "display.h"


TCHAR text_area[TEXT_Y][TEXT_X] = { 0 };	// Actual text buffer

extern HWND main_win;
extern HWND input_dialog;

int text_box_y = 0;


/***********************
* Console text display *
***********************/


/* Clear the text display */
void setup_text(void)
{	
	RECT r;

	GetClientRect(input_dialog, &r);
	
	// Determine the start location of the text box
	text_box_y = r.bottom + 1;
		
	// Clear all to null
	for (int i = 0; i < TEXT_Y; i++)
		memset((char *)text_area[i], 0, TEXT_X * sizeof(TCHAR));

}
/* End of setup_text */


/* Adds a line to the text buffer */
void add_line(char *line)
{    
    static int cur_y = 0;
	
	// Scrool the display up
    if (cur_y == TEXT_Y)
    {
        for (int i = 1; i < TEXT_Y; i++)
            memcpy(text_area[i-1], text_area[i], TEXT_X * sizeof(TCHAR));
    }
    else
        cur_y ++;

	// Convert from ascii to unicode and add to last line
    wsprintf(text_area[cur_y-1], TEXT("%S"), line);

	// Redraw
	if (main_win)
        InvalidateRect(main_win, NULL, FALSE);    
}
/* End of add line */



/* Display text box */
void display_text(void)
{
    PAINTSTRUCT ps;

    HDC hdc = BeginPaint(main_win, &ps);
 
	// Clear last text area
    Rectangle(hdc, 0, text_box_y, DISPLAY_X, DISPLAY_Y - MENU_HEIGHT + 1);
	
	// Copy the lines to the display
    for (int y = 0; y < TEXT_Y; y++)
     	ExtTextOut(hdc, 3, text_box_y + y * FONT_Y_SIZE + 1, 0, 0, 
                  text_area[y], lstrlen(text_area[y]), NULL);		     
			
	EndPaint(main_win, &ps);
}
/* End of display text */



/*****************************
* End of onsole text display *
*****************************/



